#include "apiwf.h"
#include "monlib.h"

static unsigned char pepe[128];

unsigned char *pripaddr(unsigned char *addr)
{
        printf(" IPv4 Addr: ");
	prdata(addr,4,PRDATA_IP);
}

const unsigned char *prwsop(unsigned char sop)
{
unsigned char aux;

  if(!sop)
    return("NONE");
  pepe[0]=0;
  aux=sop;
  if(sop&WSO_NOACK){
    strcat(pepe,"NOACK");
    sop&=~WSO_NOACK;
    if(sop)
      strcat(pepe,"+");
  }
  if(sop)
    strcat(pepe,"?");
  return(pepe);
}

const unsigned char *prws4op(unsigned char sop)
{
unsigned char aux;

  if(!sop)
    return("NONE");
  pepe[0]=0;
  aux=sop;
  if(sop&IP4SOP_TCP_TERM){
    strcat(pepe,"TERMSOCK");
    sop&=~IP4SOP_TCP_TERM;
    if(sop)
      strcat(pepe,"+");
  }
  if(sop)
    strcat(pepe,"?");
  return(pepe);
}

const unsigned char *prwsst(unsigned char sts)
{
  switch(sts){
  case WSS_SUCCESS:
    return("SUCCESS");
  case WSS_TX64NOACK:
    return("NOACK(MAC)");
  case WSS_PURGED:
    return("PURGED");
  case WSS_HWERR:
    return("HW_ERROR");
  case WSS_RSRCERR:
  case WSS_SCKTERR:
    return("MEMORY_FULL");
  case WSS_TOOLARGE:
    return("MESSAGE_TOO_LARGE");
  default:
    return("?");
  }
}

unsigned char *prwrop(unsigned char rop)
{
unsigned char aux;

  if(!rop)
    return("NONE");
  pepe[0]=0;
  aux=rop;
#if 0
  if(rop&WRO_ACKSENT){
    strcat(pepe,"ACKED");
    rop&=~WRO_ACKSENT;
    if(rop)
      strcat(pepe,"+");
  }
#endif
  if(rop)
    strcat(pepe,"?");
  return(pepe);
}


void prwiodata(APIwiorecv *io)
{
int i,j;
IOdata *iod;
unsigned char aux,mask=1,ch=0,cur;
  
   while(mask){
    if(io->anchannel&mask)
      ch++;
    mask<<=1;
  }
  iod=&io->iodata;
  printf("%d samples, active digital channels: %02X %02X, analog channels: %02X\n",io->samples,io->digchannel[0],io->digchannel[1],io->anchannel);

  for(i=0;i<io->samples;i++){
    printf("\t");
    if(io->digchannel[1]|io->digchannel[0]){
      printf("I/O: %X%02X  ",iod->data[0]&1,iod->data[1]);
      iod++;
    }
    mask=1;
    cur=0;
    for(j=0;j<ch;j++){
      while(!(io->anchannel&mask)){
	mask<<=1;
	cur++;
	if(!mask)
	  break;
      }
      if(cur==7)
	printf("Vcc: %umV  ",((iod->data[0])<<8)+iod->data[1]);
      else
	printf("AN%c: %X%02X  ",cur+'0',iod->data[0]&3,iod->data[1]);
      iod++;
      cur++;
      mask<<=1;
    }
    printf("\n");
  }
}

